use std::os::raw::c_int;
use std::io::Error;
use signal_hook::consts::signal::*;
use signal_hook::iterator::Signals;

use std::process;

fn main() -> Result<(), Error> {
    println!("Process ID is {}", process::id());

    const SIGNALS: &[c_int] = &[
        SIGTERM, SIGQUIT, SIGINT, SIGTSTP,
        SIGWINCH, SIGHUP, SIGCHLD, SIGCONT, SIGUSR1
    ];

    let mut signals = Signals::new(SIGNALS)?;

    'outer: loop {
        for signal in signals.pending() {
            match signal {
                SIGINT => {
                    println!("Got SIGINT");
                },
                SIGTERM => {
                    println!("Got SIGTERM");
                    break 'outer;
                },
                SIGCONT => {
                    println!("Got SIGCONT");
                },
                other_signal => {
                    println!("Got {:?}", other_signal);
                },
            }
        }
    }

    println!("Good bye cruel world!");
    Ok(())
}
