use std::io::prelude::*;
use std::process::Command;
use std::process::Stdio;

fn main() {
    // Open wc(1) for business!
    let wc = match Command::new("wc")
            .stdin(Stdio::piped())
            .stdout(Stdio::piped())
            .spawn() {
        Err(error) => panic!("Error in wc: {}", error),
        Ok(wc) => wc,
    };

    // Get the input
    let data = Command::new("env")
        .output()
        .expect("Error in env");

    // Send the input
    match wc.stdin.unwrap().write_all(&data.stdout) {
        Err(error) => panic!("Failed writing to wc: {}", error),
        Ok(_) => println!("Data sent to wc!"),
    }

    // Now, get the output
    let mut s = String::new();
    match wc.stdout.unwrap().read_to_string(&mut s) {
        Err(error) => panic!("Failed to read wc stdout: {}", error),
        Ok(_) => print!("wc(1) returned:\n{}", s),
    }
}
