use std::process::Command;

fn main() {
    Command::new("ls")
    .spawn()
    .expect("Error in command");

    // -X sorts the output alphabetically
    Command::new("ls")
    .arg("-X")
    .spawn()
    .expect("Error in command");

    // Use a different current directory
    Command::new("ls")
    .current_dir("/tmp")
    .arg("-X")
    .spawn()
    .expect("Error in command");

    Command::new("ls")
    .arg("/doesNotExist")
    .spawn()
    .expect("Error in command");

    // Command does not exist
    Command::new("sl")
    .spawn()
    .expect("Error in command");
}
